#!/usr/bin/env python

import os
import matplotlib.pyplot as plt
import matplotlib.ticker as ticker
from datetime import datetime
from utils import getDatetimeFromFileName, getMonthIndexSinceEpoch, getMonthNameFromMonthIndex, readPdfBankStatement

PATH = f'/home/benjamin/Desktop/bens_folder/bazaar/documents/bnp/bank_statements/'

os.chdir(PATH)

PRINT_TRANSACTIONS = False

MAIN_BANK_ACCOUNT = 'compte_de_cheques'

debits = []
credits_ = []
# Precise bank account
allTransactions = []

'''
def appendTransactions(x):
    global allTransactions
    allTransactions += [x]
'''

def appendTransactions(transactions, bankAccount):
    global allTransactions
    #print('Before')
    #pprint(allTransactions)
    for transaction in transactions:
        transaction['bank account'] = bankAccount
        allTransactions += [transaction]
    #print('After')
    #pprint(allTransactions)

for folder in os.listdir():
    if folder != MAIN_BANK_ACCOUNT:
        for file in os.listdir(folder):
            filePath = f'{folder}/{file}'
            print(filePath)
            transactions = readPdfBankStatement(filePath)[3]
            appendTransactions(transactions, folder)

#exit(1)
os.chdir(f'{MAIN_BANK_ACCOUNT}/')

for folder in sorted(os.listdir()):
    for file in sorted(os.listdir(folder)):
        filePath = f'{folder}/{file}'
        print(filePath)
        transactions = readPdfBankStatement(filePath)[3]
        appendTransactions(transactions, MAIN_BANK_ACCOUNT)
        if PRINT_TRANSACTIONS:
            for transaction in transactions:
                printTransaction(transaction)
        #break
    #break

from pprint import pprint
#pprint(transactions)
import operator
allTransactions.sort(key = operator.itemgetter('date'))
print(len(allTransactions))
pprint(allTransactions)

exit(0)

fig, ax = plt.subplots()
plt.title('Monthly debits and credits')
plt.xlabel('Date')
plt.ylabel('€')
ALPHA = 0.5

xTicks = range(getMonthIndexSinceEpoch(firstDatetime), getMonthIndexSinceEpoch(lastDatetime) + 1)
totalMonthlyAmountAndLabel = (
    #(totalMonthlyDebits, 'Debit'),
    #(totalMonthlyCredits, 'Credit'),
    (totalMonthlyDifferences, 'Difference'),
    (totals, 'Total'),
)
for totalMonthlyAmount, totalMonthlyLabel in totalMonthlyAmountAndLabel:
    plt.bar(xTicks, totalMonthlyAmount, alpha = ALPHA, label = totalMonthlyLabel)
plt.legend()

#plt.yscale('symlog')
ax.yaxis.set_major_formatter(ticker.StrMethodFormatter('{x:,}'))

ticksLabels = [getMonthNameFromMonthIndex(monthIndex) for monthIndex in xTicks]
plt.xticks(xTicks, ticksLabels, rotation = 90)
#plt.tight_layout()
# How to show the horizontal lines for subticks?
plt.grid(axis = 'y')

plt.show()